// http://cvs.sourceforge.net/cgi-bin/viewcvs.cgi/ming/ming/util/?hideattic=0
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <math.h>
#include "png.h"
#include "zlib.h"
#include "MemLeakCheck.h" 
// http://cvs.sourceforge.net/cgi-bin/viewcvs.cgi/ming/ming/util/?hideattic=0

#include "png2dbl.h"

int verbose = 0;
char *szerror;
#define ONE_K 1024
char szret_ConvertPngToDBL[ONE_K];
char g_szPngFile[ONE_K];

void png_read_data(png_structp png_ptr, png_bytep data, png_size_t length)
{
   png_size_t check;

   /* fread() returns 0 on error, so it is OK to store this in a png_size_t
    * instead of an int, which is what fread() actually returns.
    */
   check = (png_size_t)fread(data, (png_size_t)1, length,
      (png_FILE_p)png_ptr->io_ptr);
   if (check != length)
    check=check;
   //   png_error(png_ptr, "Read Error");
}

void error(char *s, ...)
{
 char szTemp[ONE_K];
  va_list ap;
  va_start(ap, s);
  vsprintf(szTemp,s, ap);
  va_end(ap);
  sprintf(szret_ConvertPngToDBL,"Convert Png to DBL:\n%s\n: %s\n",g_szPngFile,szTemp);
  szerror=szret_ConvertPngToDBL;
}

struct pngdata
{
  png_uint_32 width;
  png_uint_32 height;
  int bit_depth;
  int color_type;
  int num_palette;
  int channels;
  png_colorp palette;
  unsigned char *data;
};

struct pngdata readPNG(FILE *fp)
{
  struct pngdata png;
  unsigned char header[8]; 

  png_structp png_ptr;
  png_infop info_ptr, end_info;
  png_bytep *row_pointers;

  int i, rowbytes, depth;
  memset(&png,0,sizeof(png));

  if(!fp)
  {error("Couldn't open file!\n");return png;}

  fread(header, 1, 8, fp);
  if(png_sig_cmp(header, 0,8))
  {error("File doesn't appear to be a proper PNG file\n");return png;}
  png_ptr = png_create_read_struct(PNG_LIBPNG_VER_STRING, NULL, NULL, NULL);

  if(!png_ptr)
  {error("Couldn't create png_ptr\n");return png;}
 
  info_ptr = png_create_info_struct(png_ptr);

  if(!info_ptr)
  {
    png_destroy_read_struct(&png_ptr, (png_infopp)NULL, (png_infopp)NULL);
    {error("Couldn't create info_ptr\n");return png;}
  }

  end_info = png_create_info_struct(png_ptr);

  if(!end_info)
  {
    png_destroy_read_struct(&png_ptr, &info_ptr, (png_infopp)NULL);
    {error("Couldn't create end_info\n");return png;}
  }

  if(setjmp(png_ptr->jmpbuf))
  {
    png_destroy_read_struct(&png_ptr, &info_ptr, &end_info);
    fclose(fp);
    {error("Mystery error (longjmp called)\n");return png;}
  }

  png_init_io(png_ptr, fp);
  png_set_sig_bytes(png_ptr, 8);
png_set_read_fn(png_ptr,fp,png_read_data);
  png_read_info(png_ptr, info_ptr);

  png_get_IHDR(png_ptr, info_ptr, &png.width, &png.height,
	       &png.bit_depth, &png.color_type,
	       NULL, NULL, NULL);

  if(png.color_type == PNG_COLOR_TYPE_PALETTE)
  {
    png_get_PLTE(png_ptr, info_ptr, &png.palette, &png.num_palette);
  }

  /* force bitdepth of 8 if necessary */

  depth = png.bit_depth;

  if(png.bit_depth < 8)
    png_set_packing(png_ptr);

  if(png_get_valid(png_ptr, info_ptr, PNG_INFO_tRNS))
    png_set_expand(png_ptr);

  if(png.bit_depth == 16)
  {
    png_set_strip_16(png_ptr);
  }

  if(png.color_type == PNG_COLOR_TYPE_GRAY_ALPHA)
  {
    png_set_gray_to_rgb(png_ptr);
  }

  if(png.color_type == PNG_COLOR_TYPE_RGB)
  {
    png_set_filler(png_ptr, 0xff, PNG_FILLER_AFTER);
  }


  /* update info w/ the set transformations */
  png_read_update_info(png_ptr, info_ptr);

  png_get_IHDR(png_ptr, info_ptr, &png.width, &png.height,
	       &png.bit_depth, &png.color_type,
	       NULL, NULL, NULL);

  png.channels = png_get_channels(png_ptr, info_ptr);


  if(png.color_type == PNG_COLOR_TYPE_GRAY)
  {
    /* turn it into a palettized image, use the gray values as indices to
       an rgb color table */

    int i;

    png.color_type = PNG_COLOR_TYPE_PALETTE;
    png.num_palette = 1 << depth;

    png.palette = (png_color*) malloc(sizeof(png_color) * png.num_palette);

    for(i=0; i<(int)png.num_palette; ++i)
      png.palette[i].red = png.palette[i].green = png.palette[i].blue = 
	(i*255)/(png.num_palette-1);
  }
 

  /* malloc stuff */
  row_pointers = (png_bytep*) malloc(png.height*sizeof(png_bytep));
  rowbytes = png_get_rowbytes(png_ptr, info_ptr);

  png.data = (unsigned char*) malloc(png.height * rowbytes);

  for(i=0; i<(int)png.height; ++i)
    row_pointers[i] = png.data + rowbytes*i;

  png_read_image(png_ptr, row_pointers);

  if(png.color_type == PNG_COLOR_TYPE_RGB_ALPHA ||
     png.color_type == PNG_COLOR_TYPE_RGB)
  {
    /* alpha has to be pre-applied, bytes shifted */

    int x, y;
    unsigned char *p;
    int alpha;
    unsigned char r, g, b;

    if(verbose)
      printf("color type: RGB ALPHA\n");

    for(y=0; y<(int)png.height; ++y)
    {
      for(x=0; x<(int)png.width; ++x)
      {
	p = png.data + rowbytes*y + 4*x;

        r = p[0];
        g = p[1];
        b = p[2];

	alpha = p[3];

	p[0] = alpha;
	p[1] = (char)((int)(r*alpha)>>8);
	p[2] = (char)((int)(g*alpha)>>8);
	p[3] = (char)((int)(b*alpha)>>8);
      }
    }
  }

  return png;
}

static void
alignedcopy(struct pngdata png, unsigned char *data)
{
  int row;
  int alignedrowsize;
  int pngrowsize;
  unsigned char *png_data;

  alignedrowsize = (png.width * png.channels + 3) & ~3;
  png_data = png.data;
  pngrowsize = png.width * png.channels;

  for( row = 0; row < (int)png.height; row++ )
  {
    memcpy(data, png_data, pngrowsize);
    png_data += pngrowsize;
    data += alignedrowsize;
  }
}

void writeDBL(FILE *f, struct pngdata png)
{
  unsigned char *data, *outdata;
  int alignedsize;
  unsigned long outsize;
  int hasAlpha =
    png.color_type == PNG_COLOR_TYPE_GRAY_ALPHA ||
    png.color_type == PNG_COLOR_TYPE_RGB_ALPHA;

  fputc('D', f);
  fputc('B', f);
  fputc('l', f);
  fputc(hasAlpha ? 2 : 1, f);

  alignedsize = png.height * ((png.width * png.channels + 3) & ~3);

  if(png.color_type == PNG_COLOR_TYPE_PALETTE)
  {
    int tablesize = png.num_palette * sizeof(png_color);
  
    data = (unsigned char*) malloc(tablesize + alignedsize);
    memcpy(data, png.palette, tablesize);
    alignedcopy(png, data + tablesize);
    alignedsize += tablesize;
  }
  else
  {
    data = (unsigned char*) malloc(alignedsize);
    alignedcopy(png, data);
  }

  outdata = (unsigned char*) malloc(outsize = (int)floor(alignedsize*1.01+12));
  
  /* compress the RGB color table (if present) and image data one block */
  
  compress2(outdata, &outsize, data, alignedsize, 9);

  /* write the remaining file size */

  if(png.color_type == PNG_COLOR_TYPE_PALETTE)
  {
    fputc(((outsize+6)>>24)&0xff, f);
    fputc(((outsize+6)>>16)&0xff, f);
    fputc(((outsize+6)>>8)&0xff, f);
    fputc((outsize+6)&0xff, f);
  }
  else
  {
    fputc(((outsize+5)>>24)&0xff, f);
    fputc(((outsize+5)>>16)&0xff, f);
    fputc(((outsize+5)>>8)&0xff, f);
    fputc((outsize+5)&0xff, f);
  }

  /* UInt8 format
     3: 8bit data
     4: 16bit data
     5: 32bit data */

  if(png.bit_depth != 8)
  { error("Can't deal with bit depth %i!", png.bit_depth);return;}

  if(png.color_type == PNG_COLOR_TYPE_PALETTE)
    fputc(3, f);
  else
    fputc(5, f);

  fputc(png.width&0xff, f);
  fputc((png.width>>8)&0xff, f);

  fputc(png.height&0xff, f);
  fputc((png.height>>8)&0xff, f);

  if(png.color_type == PNG_COLOR_TYPE_PALETTE)
    fputc(png.num_palette-1, f);

  if(fwrite(outdata, sizeof(char), outsize, f) != outsize)
  { error("Didn't write all of the file!");return;};
}

long png2dbl_thread_lock;

#define SPIN_AND_GET_ACCESS \
{\
 for(;;)\
 {\
  if(InterlockedExchange(&png2dbl_thread_lock,1)!=0)\
   /* prior value for thread_lock was 1 so another thread*/\
   /*still has access*/\
   Sleep(0);\
  else\
   /*prior value was 0 and it is now set to 1 to*/\
   /*indicate that this thread has access*/\
   /*Now everything we do is atomic*/\
   break;\
 }\
}

#define CEDE_ACCESS  {InterlockedExchange(&png2dbl_thread_lock, 0);}

PNG2DBL_DLL_A char * PNG2DBL_DLL_B Png2DBL(char *szPngFile,char *szDblFile)
{
 // on success returns NULL.
 // on error, returns a string describing the error.
 // Shortcut: szDblFile can be NULL to convert to a file with same name but extension .dbl
 // With this option, it change the extension of szPngFile accordingly so that on return it
 // is the file name for the new converted file.
  int len;
  char *szret=NULL;
  struct pngdata png;
  int npointers_freed;
  if(!szPngFile)
   return "ConvertPngToDBL - called with NULL pointer for png file";
  len = strlen(szPngFile);
  strncpy(g_szPngFile,szPngFile,ONE_K);
  g_szPngFile[ONE_K-1]='\0';
  if(strcmpi(szPngFile+len-4, ".png") != 0)
  {
   sprintf
    (szret_ConvertPngToDBL
    ,"Couldn't convert %s to DBL - required extension for source file is .PNG"
    ,szPngFile
     );
    return szret_ConvertPngToDBL;
  }
  SPIN_AND_GET_ACCESS  
  png = readPNG(fopen(szPngFile, "rb"));
  if(szerror)
  {
   CEDE_ACCESS
   return szerror;
  }
  if(szDblFile==NULL)
  {
    szPngFile[len-3] = 'd';
    szPngFile[len-2] = 'b';
    szPngFile[len-1] = 'l';
    szDblFile=szPngFile;
  }
  {
   FILE *fp=fopen(szDblFile, "wb");
   if(fp)
    writeDBL(fp, png);
   if(szerror)
    szret=szerror;
   if(ferror(fp))
   {
    sprintf
     (szret_ConvertPngToDBL
     ,"Error on output while converting %s to DBL:\n\n"
     "%s"
     ,szPngFile
     ,strerror(errno)
     );
    szret=szret_ConvertPngToDBL;
   }
   if(fp)
    fclose(fp);
  }
  npointers_freed=MemLeakCheckAndFree();
  CEDE_ACCESS
  return szret;
}

