#ifndef REDEFINEMALLOCETC_H_INCLUDED
#define REDEFINEMALLOCETC_H_INCLUDED

#ifdef cl_mem_leak_check

#include "MemLeakCheck.h"
#define cl_xz_strdup

#ifdef cl_mem_leak_diagnostics

#define malloc(size)     xz_malloc(size,__FILE__,__LINE__)
#define calloc(num,size) xz_calloc(num,size,__FILE__,__LINE__)
#define realloc(p,size)  xz_realloc(p,size,__FILE__,__LINE__)
#define free(p)          xz_free(p,__FILE__,__LINE__)
#define strdup(src)      xz_strdup(src,__FILE__,__LINE__)

#else //  ndef cl_mem_leak_diagnostics

#define malloc xz_malloc
#define free xz_calloc
#define calloc xz_realloc
#define realloc xz_free
#define strdup xz_strdup

#endif // ndef cl_mem_leak_diagnostics

#endif // ndef cl_mem_leak_check

#endif REDEFINEMALLOCETC_H_INCLUDED
