/*
    Ming, an SWF output library
    Copyright (C) 2001  Opaque Industries - http://www.opaque.net/

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "_cl.h"

#include <stdlib.h>
#include <math.h>
#include "block.h"

#include "gradient.h"

static SWFGradient *NewGradientsAdded;
static int nNewGradientsAdded;
static int nMaxNewGradientsAdded;
#define MOVIE_ITEMS_ADDED_INCR 1024
static int ntotal_new_gradients_added;
static int  ntest_compactify_gradients_added_at;

static void CompactifyNewGradientsArray(void)
{
 int i=0;
 int ipos=0;
 for(i=0;i<nNewGradientsAdded;i++)
  if(NewGradientsAdded[i])
  {
   if(ipos==i)
    ipos++;
   else
   {
    SWFGradient item=NewGradientsAdded[i];
    item->nrecord=i;
    NewGradientsAdded[ipos++]=NewGradientsAdded[i];
   }
  }
 nNewGradientsAdded=ipos;
 ntest_compactify_gradients_added_at=ntotal_new_gradients_added+max(1024,nNewGradientsAdded/2);
}

WM_DLL_A void WM_DLL_B MingRecordNewGradientAdded(SWFGradient item)
{
 int i=0;
 if(nNewGradientsAdded+1>nMaxNewGradientsAdded)
 {
  int new_nMaxNewGradientsAdded=nMaxNewGradientsAdded+MOVIE_ITEMS_ADDED_INCR;
  SWFGradient *NewNewGradientsAdded=(SWFGradient*)_realloc_((void *)NewGradientsAdded,new_nMaxNewGradientsAdded*sizeof(SWFGradient *));
  if(NewNewGradientsAdded)
  {
   NewGradientsAdded=NewNewGradientsAdded;
   nMaxNewGradientsAdded=new_nMaxNewGradientsAdded;
  }
  else
  {
   return;
  }
 }
 item->nrecord=nNewGradientsAdded;
 NewGradientsAdded[nNewGradientsAdded++]=item;
 ntotal_new_gradients_added++;
 if(ntotal_new_gradients_added>=ntest_compactify_gradients_added_at)
  CompactifyNewGradientsArray();
 return;
}

WM_DLL_A void WM_DLL_B MingUnRecordNewGradientRemoved(SWFGradient item)
{
 int i=item->nrecord;
 if(i>=0&&i<nNewGradientsAdded)
  if(NewGradientsAdded[i]==item)
  {
   NewGradientsAdded[i]=NULL;
   return;
  }
 return;
}

WM_DLL_A void WM_DLL_B MingRemoveAllGradients(void)
{
 int i=0;
 for(i=0;i<nNewGradientsAdded;i++)
  if(NewGradientsAdded[i])
  {
   destroySWFGradient(NewGradientsAdded[i]);
   NewGradientsAdded[i]=NULL;
  }
  _free_(NewGradientsAdded);
  nNewGradientsAdded=0;
  nMaxNewGradientsAdded=0;
  NewGradientsAdded=NULL;
 return;
}
 

 
WM_DLL_A SWFGradient WM_DLL_B newSWFGradient()
{
  SWFGradient gradient = _calloc_(1, GRADIENT_SIZE);
  MingRecordNewGradientAdded((SWFGradient)gradient);
  return gradient;
}
void destroySWFGradient(SWFGradient gradient)
{
 MingUnRecordNewGradientRemoved(gradient);
 _free_(gradient);
}

WM_DLL_A void WM_DLL_B SWFGradient_addEntry(SWFGradient gradient,
			  float ratio, byte r, byte g, byte b, byte a)
{
  int nGrads = gradient->nGrads;

  if(nGrads == 8)
    return;

  gradient->entries[nGrads].ratio = (byte)floor(255*ratio);
  gradient->entries[nGrads].r = r;
  gradient->entries[nGrads].g = g;
  gradient->entries[nGrads].b = b;
  gradient->entries[nGrads].a = a;

  ++(gradient->nGrads);
}

WM_DLL_A void WM_DLL_B SWFOutput_writeGradient(SWFOutput out, SWFGradient gradient,
			     SWFBlocktype shapeType)
{
  int i, nGrads = min(gradient->nGrads, 8);

  SWFOutput_writeUInt8(out, gradient->nGrads); /* only 1-8 allowed */

  for(i=0; i<nGrads; ++i)
  {
    SWFOutput_writeUInt8(out, gradient->entries[i].ratio);
    SWFOutput_writeUInt8(out, gradient->entries[i].r);
    SWFOutput_writeUInt8(out, gradient->entries[i].g);
    SWFOutput_writeUInt8(out, gradient->entries[i].b);

    if(shapeType == SWF_DEFINESHAPE3)
      SWFOutput_writeUInt8(out, gradient->entries[i].a);
  }
}

WM_DLL_A void WM_DLL_B SWFOutput_writeMorphGradient(SWFOutput out,
				  SWFGradient gradient1, SWFGradient gradient2)
{
  int i, nGrads = min(min(gradient1->nGrads, gradient2->nGrads), 8);

  SWFOutput_writeUInt8(out, nGrads); /* only 1-8 allowed */

  for(i=0; i<nGrads; ++i)
  {
    SWFOutput_writeUInt8(out, gradient1->entries[i].ratio);
    SWFOutput_writeUInt8(out, gradient1->entries[i].r);
    SWFOutput_writeUInt8(out, gradient1->entries[i].g);
    SWFOutput_writeUInt8(out, gradient1->entries[i].b);
    SWFOutput_writeUInt8(out, gradient1->entries[i].a);
    SWFOutput_writeUInt8(out, gradient2->entries[i].ratio);
    SWFOutput_writeUInt8(out, gradient2->entries[i].r);
    SWFOutput_writeUInt8(out, gradient2->entries[i].g);
    SWFOutput_writeUInt8(out, gradient2->entries[i].b);
    SWFOutput_writeUInt8(out, gradient2->entries[i].a);
  }
}

  
  
           